/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.thin.tutorial.web.action;

import jp.terasoluna.fw.service.thin.BLogicMessage;
import jp.terasoluna.fw.service.thin.BLogicMessages;
import jp.terasoluna.fw.service.thin.BLogicResult;
import jp.terasoluna.fw.web.struts.actions.AbstractBLogicAction;
import jp.terasoluna.thin.tutorial.service.bean.UserBean;
import jp.terasoluna.thin.tutorial.service.blogic.RegisterBLogic;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.Globals;

/**
 * 入力情報登録アクション。
 *
 * 登録を行うビジネスロジックを呼び、入力された値をデータベースに登録する。
 *
 */
public class RegisterAction extends AbstractBLogicAction<UserBean> {

    /**
     * ログクラス。
     */
    private Log log = LogFactory.getLog(RegisterAction.class);

    /**
     * 入力情報登録ビジネスロジッククラス。
     */
    private RegisterBLogic registBLogic = null;

    /**
     * 入力情報登録ビジネスロジックを返却する。
     *
     * @return 保持する入力情報登録ビジネスロジック
     */
    public RegisterBLogic getRegistBLogic() {
        return registBLogic;
    }

    /**
     * 入力情報登録ビジネスロジックを設定する。
     *
     * @param registBLogic 入力情報登録ビジネスロジック
     */
    public void setRegistBLogic(RegisterBLogic registBLogic) {
        this.registBLogic = registBLogic;
    }

    /**
     * ビジネスロジックを実行し、結果を返却する。
     *
     * @param bean 入力された値を保持したbean
     * @return 登録結果を保持したBLogicResult
     * @throws Exception 例外
     */
    @Override
    public BLogicResult doExecuteBLogic(UserBean bean) throws Exception {

        if (log.isDebugEnabled()) {
            log.debug("doExecuteBLogic Start.");
        }

        //BLogicResultの生成、結果の設定
        BLogicResult result = new BLogicResult();

        //入力情報ビジネスロジックの実行
        //返却値が、falseの場合は重複エラー。
        //trueの場合は登録処理が正常に終了。
        if (!registBLogic.register(bean)) {

            //重複エラー時の処理
            setErrors(result, "errors.input.id.repeat", "error");
            result.setResultObject(bean);
            return result;
        }

        //正常な場合は、結果文字列を設定して返却する。
        result.setResultString("success");
        result.setResultObject(new UserBean());
        return result;
    }

    /**
     * 引数のBLogicResultオブジェクトに
     * エラーメッセージおよび結果文字列を設定する。
     * 
     * @param result BLogicResultオブジェクト
     * @param errorKey 設定するエラーキー
     * @param resultString 結果文字列
     */
    private void setErrors(BLogicResult result, String errorKey,
            String resultString) {
        BLogicMessages errors = result.getErrors();
        if (errors == null) {
            errors = new BLogicMessages();
        }
        errors.add(Globals.ERROR_KEY,
                new BLogicMessage(errorKey));
        result.setErrors(errors);
        result.setResultString(resultString);
    }
}
